Update to latest bootstrap
[awesomized/libmemcached] / bootstrap.sh
index b548686f03b0cf280ba22dda72fa1da5d93fe19b..4bc2148a84f7ad57e5e78fc0905048c52e27f7d0 100755 (executable)
@@ -1,6 +1,6 @@
 #!/bin/bash
 # 
-# Copyright (C) 2012 Brian Aker
+# Copyright (C) 2012-2013 Brian Aker
 # All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
 
 command_not_found_handle ()
 {
-  echo "Command not found: '$@'"
-  exit 127
+  warn "$@: command not found"
+
+  #if $DEBUG; then 
+    echo ""
+    echo "Stack trace:"
+    local frame=0
+    while caller $frame; do
+      ((frame++));
+    done
+    echo ""
+  #fi
+
+  return 127
+}
+
+function error ()
+{ 
+  echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
 }
 
 function die ()
@@ -55,6 +71,12 @@ function die ()
   exit 1; 
 }
 
+function warn ()
+{ 
+  echo "$BASH_SOURCE:$BASH_LINENO: $@"
+  #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
+}
+
 function nassert ()
 {
   local param_name=\$"$1"
@@ -77,7 +99,7 @@ function assert ()
   fi
 }
 
-assert_file ()
+function assert_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -85,7 +107,7 @@ assert_file ()
   fi
 }
 
-assert_no_file ()
+function assert_no_file ()
 {
   if [ -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
@@ -93,7 +115,15 @@ assert_no_file ()
   fi
 }
 
-assert_exec_file ()
+function assert_no_directory ()
+{
+  if [ -d "$1" ]; then
+    echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
+    exit 1;
+  fi
+}
+
+function assert_exec_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -106,12 +136,12 @@ assert_exec_file ()
   fi
 }
 
-command_exists ()
+function command_exists ()
 {
   type "$1" &> /dev/null ;
 }
 
-rebuild_host_os ()
+function rebuild_host_os ()
 {
   HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
   if [ -z "$1" ]; then
@@ -121,8 +151,9 @@ rebuild_host_os ()
   fi
 }
 
-#  Valid values are: darwin,fedora,rhel,ubuntu
-set_VENDOR_DISTRIBUTION ()
+# Validate the distribution name, or toss an erro
+#  values: darwin,fedora,rhel,ubuntu,debian,opensuse
+function set_VENDOR_DISTRIBUTION ()
 {
   local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
   case "$dist" in
@@ -135,9 +166,15 @@ set_VENDOR_DISTRIBUTION ()
     rhel)
       VENDOR_DISTRIBUTION='rhel'
       ;;
+    debian)
+      VENDOR_DISTRIBUTION='debian'
+      ;;
     ubuntu)
       VENDOR_DISTRIBUTION='ubuntu'
       ;;
+    suse)
+      VENDOR_DISTRIBUTION='opensuse'
+      ;;
     opensuse)
       VENDOR_DISTRIBUTION='opensuse'
       ;;
@@ -147,21 +184,59 @@ set_VENDOR_DISTRIBUTION ()
   esac
 }
 
-set_VENDOR_RELEASE ()
+# Validate a Vendor's release name/number 
+function set_VENDOR_RELEASE ()
 {
   local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
-  case "$VENDOR_DISTRIBUTION" in
+
+  if $DEBUG; then 
+    echo "VENDOR_DISTRIBUTION:$VENDOR_DISTRIBUTION"
+    echo "VENDOR_RELEASE:$release"
+  fi
+
+  case $VENDOR_DISTRIBUTION in
     darwin)
-      VENDOR_RELEASE='mountain'
+      case $release in
+        10.6*)
+          VENDOR_RELEASE='snow_leopard'
+          ;;
+        10.7*)
+          VENDOR_RELEASE='mountain'
+          ;;
+        mountain)
+          VENDOR_RELEASE='mountain'
+          ;;
+        10.8.*)
+          echo "mountain_lion"
+          VENDOR_RELEASE='mountain_lion'
+          ;;
+        *)
+          echo $VENDOR_RELEASE
+          VENDOR_RELEASE='unknown'
+          ;;
+      esac
       ;;
     fedora)
       VENDOR_RELEASE="$release"
+      if [[ "x$VENDOR_RELEASE" == '18' ]]; then
+        VENDOR_RELEASE='sphericalcow'
+      fi
       ;;
     rhel)
       VENDOR_RELEASE="$release"
       ;;
+    debian)
+      VENDOR_RELEASE="$release"
+      ;;
     ubuntu)
       VENDOR_RELEASE="$release"
+      if [[ "x$VENDOR_RELEASE" == 'x12.04' ]]; then
+        VENDOR_RELEASE="precise"
+      elif [[ "x$VENDOR_RELEASE" == 'x12.10' ]]; then
+        VENDOR_RELEASE="quantal"
+      elif [[ "x$VENDOR_RELEASE" == 'x13.04' ]]; then
+        VENDOR_RELEASE="raring"
+      fi
       ;;
     opensuse)
       VENDOR_RELEASE="$release"
@@ -176,8 +251,8 @@ set_VENDOR_RELEASE ()
 }
 
 
-#  Valid values are: apple, redhat, centos, canonical
-set_VENDOR ()
+#  Valid values are: apple, redhat, centos, canonical, oracle, suse
+function set_VENDOR ()
 {
   local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
 
@@ -188,12 +263,30 @@ set_VENDOR ()
     redhat)
       VENDOR='redhat'
       ;;
+    fedora)
+      VENDOR='redhat'
+      ;;
+    redhat-release-server-*)
+      VENDOR='redhat'
+      ;;
+    enterprise-release-*)
+      VENDOR='oracle'
+      ;;
     centos)
       VENDOR='centos'
       ;;
     canonical)
       VENDOR='canonical'
       ;;
+    ubuntu)
+      VENDOR='canonical'
+      ;;
+    debian)
+      VENDOR='debian'
+      ;;
+    opensuse)
+      VENDOR='suse'
+      ;;
     suse)
       VENDOR='suse'
       ;;
@@ -204,22 +297,43 @@ set_VENDOR ()
 
   set_VENDOR_DISTRIBUTION $2
   set_VENDOR_RELEASE $3
+
+  # Set which vendor/versions we trust for autoreconf
+  case $VENDOR_DISTRIBUTION in
+    fedora)
+      if [[ "x$VENDOR_RELEASE" == 'x18' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      elif [[ "x$VENDOR_RELEASE" == 'xsphericalcow' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      elif [[ "x$VENDOR_RELEASE" == 'x19' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      fi
+      ;;
+    canonical)
+      if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      elif [[ "x$VENDOR_RELEASE" == 'xquantal' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      fi
+      ;;
+  esac
+
 }
 
-determine_target_platform ()
+function determine_target_platform ()
 {
   UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
   UNAME_KERNEL=`(uname -s) 2>/dev/null`  || UNAME_SYSTEM=unknown
   UNAME_KERNEL_RELEASE=`(uname -r) 2>/dev/null` || UNAME_KERNEL_RELEASE=unknown
 
-  if [[ $(uname) == 'Darwin' ]]; then
+  if [[ -x '/usr/bin/sw_vers' ]]; then 
+    local _VERSION=`/usr/bin/sw_vers -productVersion`
+    set_VENDOR 'apple' 'darwin' $_VERSION
+  elif [[ $(uname) == 'Darwin' ]]; then
     set_VENDOR 'apple' 'darwin' 'mountain'
   elif [[ -f '/etc/fedora-release' ]]; then 
     local fedora_version=`cat /etc/fedora-release | awk ' { print $3 } '`
     set_VENDOR 'redhat' 'fedora' $fedora_version
-    if [[ "x$VENDOR_RELEASE" == 'x17' ]]; then
-      AUTORECONF_REBUILD_HOST=true
-    fi
   elif [[ -f '/etc/centos-release' ]]; then
     local centos_version=`cat /etc/centos-release | awk ' { print $7 } '`
     set_VENDOR 'centos' 'rhel' $centos_version
@@ -229,20 +343,24 @@ determine_target_platform ()
     set_VENDOR 'suse' $suse_distribution $suse_version
   elif [[ -f '/etc/redhat-release' ]]; then
     local rhel_version=`cat /etc/redhat-release | awk ' { print $7 } '`
-    set_VENDOR 'redhat' 'rhel' $rhel_version
+    local _vendor=`rpm -qf /etc/redhat-release`
+    set_VENDOR $_vendor 'rhel' $rhel_version
+  elif [[ -f '/etc/os-release' ]]; then 
+    source '/etc/os-release'
+    set_VENDOR $ID $ID $VERSION_ID
+  elif [[ -x '/usr/bin/lsb_release' ]]; then 
+    local _ID=`/usr/bin/lsb_release -s -i`
+    local _VERSION=`/usr/bin/lsb_release -s -r`
+    set_VENDOR $_ID $_ID $_VERSION_ID
   elif [[ -f '/etc/lsb-release' ]]; then 
-    local debian_DISTRIB_ID=`cat /etc/lsb-release | grep DISTRIB_ID | awk -F= ' { print $2 } '`
-    local debian_version=`cat /etc/lsb-release | grep DISTRIB_CODENAME | awk -F= ' { print $2 } '`
-    set_VENDOR 'canonical' $debian_DISTRIB_ID $debian_version
-    if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
-      AUTORECONF_REBUILD_HOST=true
-    fi
+    source '/etc/lsb-release'
+    set_VENDOR 'canonical' $DISTRIB_ID $DISTRIB_CODENAME
   fi
 
   rebuild_host_os
 }
 
-run_configure ()
+function run_configure ()
 {
   # We will run autoreconf if we are required
   run_autoreconf_if_required
@@ -252,6 +370,10 @@ run_configure ()
     die "Programmer error, we entered run_configure with a stacked directory"
   fi
 
+  if ! command_exists "$CONFIGURE"; then
+    die "$CONFIGURE does not exist"
+  fi
+
   local BUILD_DIR="$1"
   if [[ -n "$BUILD_DIR" ]]; then
     rm -r -f $BUILD_DIR
@@ -260,40 +382,58 @@ run_configure ()
   fi
 
   # Arguments for configure
-  local CONFIGURE_ARG= 
+  local BUILD_CONFIGURE_ARG= 
+
+  # If ENV DEBUG is set we enable both debug and asssert, otherwise we see if this is a VCS checkout and if so enable assert
+  # Set ENV ASSERT in order to enable assert.
+  # If we are doing a valgrind run, we always compile with assert disabled
+  if $valgrind_run; then
+    BUILD_CONFIGURE_ARG+= " CXXFLAGS=-DNDEBUG "
+    BUILD_CONFIGURE_ARG+= " CFLAGS=-DNDEBUG "
+  else
+    if $DEBUG; then 
+      BUILD_CONFIGURE_ARG+=' --enable-debug --enable-assert'
+    elif [[ -n "$VCS_CHECKOUT" ]]; then
+      BUILD_CONFIGURE_ARG+=' --enable-assert'
+    fi
+  fi
 
-  # Set ENV DEBUG in order to enable debugging
-  if $DEBUG; then 
-    CONFIGURE_ARG='--enable-debug'
+  if [[ -n "$CONFIGURE_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG+=" $CONFIGURE_ARG"
   fi
 
-  # Set ENV ASSERT in order to enable assert
-  if [[ -n "$ASSERT" ]]; then 
-    local ASSERT_ARG=
-    ASSERT_ARG='--enable-assert'
-    CONFIGURE_ARG="$ASSERT_ARG $CONFIGURE_ARG"
+  if [[ -n "$PREFIX_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG+=" $PREFIX_ARG"
   fi
 
+  ret=1;
   # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
   case $HOST_OS in
     *-darwin-*)
-      CC=clang CXX=clang++ $top_srcdir/configure $CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $CONFIGURE_ARG $PREFIX_ARG"
+      CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG"
+      ret=$?
       ;;
     rhel-5*)
-      command_exists gcc44 || die "Could not locate gcc44"
-      CC=gcc44 CXX=gcc44 $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $CONFIGURE_ARG $PREFIX_ARG"
+      command_exists 'gcc44' || die "Could not locate gcc44"
+      CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG"
+      ret=$?
       ;;
     *)
-      $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute configure $CONFIGURE_ARG $PREFIX_ARG"
+      $CONFIGURE $BUILD_CONFIGURE_ARG
+      ret=$?
       ;;
   esac
 
+  if [ $ret -ne 0 ]; then
+    die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG"
+  fi
+
   if [ ! -f 'Makefile' ]; then
-    die "Programmer error, configure was run but no Makefile existed afterward"
+    die "Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
   fi
 }
 
-setup_gdb_command () {
+function setup_gdb_command () {
   GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
   echo 'set logging overwrite on' > $GDB_TMPFILE
   echo 'set logging on' >> $GDB_TMPFILE
@@ -304,54 +444,81 @@ setup_gdb_command () {
   GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
 }
 
-setup_valgrind_command () {
+function setup_valgrind_command () {
   VALGRIND_PROGRAM=`type -p valgrind`
   if [[ -n "$VALGRIND_PROGRAM" ]]; then
-    VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
+    VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --malloc-fill=A5 --free-fill=DE --xml=yes --xml-file=\"valgrind-%p.xml\""
   fi
 }
 
-push_PREFIX_ARG ()
+function save_BUILD ()
 {
-  if [[ -n "$PREFIX_ARG" ]]; then
-    OLD_PREFIX_ARG=$PREFIX_ARG
-    PREFIX_ARG=
+  if [[ -n "$OLD_CONFIGURE" ]]; then
+    die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
   fi
 
-  if [[ -n "$1" ]]; then
-    PREFIX_ARG="--prefix=$1"
+  if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+    die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
   fi
-}
 
-pop_PREFIX_ARG ()
-{
-  if [[ -n "$OLD_PREFIX_ARG" ]]; then
-    PREFIX_ARG=$OLD_TESTS_ENVIRONMENT
-    OLD_PREFIX_ARG=
-  else
-    PREFIX_ARG=
+  if [[ -n "$OLD_PREFIX" ]]; then
+    die "OLD_PREFIX($OLD_PREFIX) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$OLD_MAKE" ]]; then
+    die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
   fi
-}
 
-push_TESTS_ENVIRONMENT ()
-{
   if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
-    die "OLD_TESTS_ENVIRONMENT was set on push, programmer error!"
+    die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$CONFIGURE" ]]; then
+    OLD_CONFIGURE=$CONFIGURE
+  fi
+
+  if [[ -n "$CONFIGURE_ARG" ]]; then
+    OLD_CONFIGURE_ARG=$CONFIGURE_ARG
+  fi
+
+  if [[ -n "$MAKE" ]]; then
+    OLD_MAKE=$MAKE
   fi
 
   if [[ -n "$TESTS_ENVIRONMENT" ]]; then
     OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
-    TESTS_ENVIRONMENT=
   fi
 }
 
-pop_TESTS_ENVIRONMENT ()
+function restore_BUILD ()
 {
-  TESTS_ENVIRONMENT=
+  if [[ -n "$OLD_CONFIGURE" ]]; then
+    CONFIGURE=$OLD_CONFIGURE
+  fi
+
+  if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+    CONFIGURE_ARG=$OLD_CONFIGURE_ARG
+  fi
+
+  if [[ -n "$OLD_PREFIX" ]]; then
+    PREFIX_ARG=$OLD_PREFIX
+  fi
+
+  if [[ -n "$OLD_MAKE" ]]; then
+    MAKE=$OLD_MAKE
+  fi
+
   if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
     TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
-    OLD_TESTS_ENVIRONMENT=
   fi
+
+  OLD_CONFIGURE=
+  OLD_CONFIGURE_ARG=
+  OLD_PREFIX=
+  OLD_MAKE=
+  OLD_TESTS_ENVIRONMENT=
+
+  export -n CC CXX
 }
 
 function safe_pushd ()
@@ -380,11 +547,6 @@ function safe_popd ()
 
 function make_valgrind ()
 {
-  if [[ "$VENDOR_DISTRIBUTION" == 'darwin' ]]; then
-    make_darwin_malloc
-    return
-  fi
-
   # If the env VALGRIND_COMMAND is set then we assume it is valid
   local valgrind_was_set=false
   if [[ -z "$VALGRIND_COMMAND" ]]; then
@@ -402,10 +564,12 @@ function make_valgrind ()
     return 1
   fi
 
-  # If we are required to run configure, do so now
-  run_configure_if_required
+  save_BUILD
 
-  push_TESTS_ENVIRONMENT
+  valgrind_run=true
+
+  # If we are required to run configure, do so now
+  run_configure
 
   # If we don't have a configure, then most likely we will be missing libtool
   assert_file 'configure'
@@ -415,15 +579,29 @@ function make_valgrind ()
     TESTS_ENVIRONMENT="$VALGRIND_COMMAND"
   fi
 
-  make_target 'check' || return 1
+  make_target 'check'
+  ret=$?
+
+  # If we aren't going to error, we will clean up our environment
+  if [ "$ret" -eq 0 ]; then
+     make 'distclean'
+  fi
+
+  valgrind_run=false
 
-  pop_TESTS_ENVIRONMENT
+  restore_BUILD
+
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
 }
 
 function make_install_system ()
 {
   local INSTALL_LOCATION=$(mktemp -d /tmp/XXXXXXXXXX)
-  push_PREFIX_ARG $INSTALL_LOCATION
+
+  save_BUILD
+  PREFIX_ARG="--prefix=$INSTALL_LOCATION"
 
   if [ ! -d $INSTALL_LOCATION ] ; then
     die "ASSERT temp directory not found '$INSTALL_LOCATION'"
@@ -431,17 +609,12 @@ function make_install_system ()
 
   run_configure #install_buid_dir
 
-  push_TESTS_ENVIRONMENT
-
   make_target 'install'
 
   make_target 'installcheck'
 
   make_target 'uninstall'
 
-  pop_TESTS_ENVIRONMENT
-  pop_PREFIX_ARG
-
   rm -r -f $INSTALL_LOCATION
   make 'distclean'
 
@@ -449,6 +622,7 @@ function make_install_system ()
     die "ASSERT Makefile should not exist"
   fi
 
+  restore_BUILD
   safe_popd
 }
 
@@ -498,24 +672,166 @@ function make_for_snapshot ()
   snapshot_check
 }
 
-function make_for_mingw32 ()
+function check_mingw ()
+{
+  command_exists 'mingw64-configure'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  command_exists 'mingw64-make'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function check_clang ()
+{
+  command_exists 'clang'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function check_clang_analyzer ()
+{
+  command_exists 'scan-build'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function make_skeleton ()
+{
+  run_configure
+  ret=$?
+
+  if [ $ret -eq 0 ]; then
+    assert_file 'Makefile'
+
+    make_target 'all' 'warn'
+    ret=$?
+    if [ $ret -ne 0 ]; then
+      warn "$MAKE failed"
+    else
+      if [[ -n "$DISPLAY" ]]; then
+        if command_exists 'wine'; then
+          TESTS_ENVIRONMENT='wine'
+        fi
+      fi
+
+      if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+        make_target 'check' 'warn' || warn "$MAKE check failed"
+        ret=$?
+      fi
+    fi
+
+    if $jenkins_build_environment; then
+      make_target 'clean' 'warn'
+    fi
+  fi
+
+  return $ret
+}
+
+function make_for_mingw ()
 {
+  if ! check_mingw; then
+    return 1
+  fi
+
   # Make sure it is clean
   if [ -f Makefile -o -f configure ]; then
     make_maintainer_clean
   fi
-  assert_no_file 'Makefile'
 
-  if command_exists mingw32-configure; then
-    run_autoreconf
+  run_autoreconf
 
-    mingw32-configure || die 'mingw32-configure failed'
-    assert_file 'Makefile'
+  save_BUILD
 
-    if command_exists mingw32-make; then
-      mingw32-make || die 'mingw32-make failed'
-    fi
+  CONFIGURE='mingw64-configure'
+  MAKE='mingw64-make'
+  CONFIGURE_ARGS='--enable-static --disable-shared'
+
+  make_skeleton
+  ret=$?
+
+  restore_BUILD
+
+  return $ret
+}
+
+function make_for_clang ()
+{
+  if ! check_clang; then
+    return 1
+  fi
+
+  # Make sure it is clean
+  if [ -f Makefile -o -f configure ]; then
+    make_maintainer_clean
+  fi
+
+  run_autoreconf
+
+  save_BUILD
+
+  CC=clang CXX=clang++
+  export CC CXX
+
+  make_skeleton
+  ret=$?
+
+  make_target 'check'
+
+  restore_BUILD
+
+  return $ret
+}
+
+function make_for_clang_analyzer ()
+{
+  if ! check_clang; then
+    return 1
+  fi
+
+  if ! check_clang_analyzer; then
+    die 'clang-analyzer was not found'
   fi
+
+  # Make sure it is clean
+  if [ -f Makefile -o -f configure ]; then
+    make_maintainer_clean
+  fi
+
+  run_autoreconf
+
+  save_BUILD
+
+  CC=clang CXX=clang++
+  export CC CXX
+  CONFIGURE_ARGS='--enable-debug'
+
+  make_skeleton
+  ret=$?
+
+  make_target 'clean' 'warn'
+
+  scan-build -o clang-html make -j4 -k
+
+  restore_BUILD
+
+  return $ret
 }
 
 # If we are locally testing, we should make sure the environment is setup correctly
@@ -540,7 +856,13 @@ function make_universe ()
   make_valgrind
   make_gdb
   make_rpm
-  make_for_mingw32
+  make_for_clang
+  make_for_clang_analyzer
+
+  if [ check_mingw -eq 0 ]; then
+    make_for_mingw
+  fi
+
   make_distcheck
   make_install_system
 }
@@ -573,21 +895,16 @@ function make_for_continuus_integration ()
       assert_exec_file 'configure'
       assert_file 'Makefile'
 
-      make_target 'all'
-
       # make rpm includes "make distcheck"
       if [[ -f rpm.am ]]; then
+        make_target 'all'
         make_rpm
       elif [[ -d rpm ]]; then
+        make_target 'all'
         make_rpm
       else
         make_distcheck
       fi
-
-      assert_exec_file 'configure'
-      assert_file 'Makefile'
-
-      make_install_system
       ;;
     *-precise-*)
       run_configure
@@ -595,19 +912,23 @@ function make_for_continuus_integration ()
       assert_exec_file 'configure'
       assert_file 'Makefile'
 
-      make_target 'all'
-
       make_distcheck
+      ;;
+    *-quantal-*)
+      run_configure
 
       assert_exec_file 'configure'
       assert_file 'Makefile'
 
-      make_valgrind
+      make_distcheck
+      ;;
+    *-raring-*)
+      run_configure
 
       assert_exec_file 'configure'
       assert_file 'Makefile'
 
-      make_install_system
+      make_distcheck
       ;;
     *)
       make_jenkins_default
@@ -631,13 +952,20 @@ function self_test ()
   eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
 }
 
-function make_gdb ()
+function make_install_html ()
 {
   run_configure_if_required
+  assert_file 'configure'
+
+  make_target 'install-html'
+}
 
-  if command_exists gdb; then
+function make_gdb ()
+{
+  save_BUILD
 
-    push_TESTS_ENVIRONMENT
+  if command_exists 'gdb'; then
+    run_configure_if_required
 
     # Set ENV GDB_COMMAND
     if [[ -z "$GDB_COMMAND" ]]; then
@@ -652,21 +980,25 @@ function make_gdb ()
       TESTS_ENVIRONMENT="$GDB_COMMAND"
     fi
 
-    make_target check
+    make_target 'check'
 
     if [ -f 'gdb.txt' ]; then
       rm 'gdb.txt'
     fi
 
-    pop_TESTS_ENVIRONMENT
-
     if [ -f '.gdb_history' ]; then
       rm '.gdb_history'
     fi
+
+    if $jenkins_build_environment; then
+      make_target 'clean'
+    fi
   else
     echo 'gdb was not present'
     return 1
   fi
+
+  restore_BUILD
 }
 
 # $1 target to compile
@@ -692,11 +1024,19 @@ function make_target ()
     die "MAKE was not set"
   fi
 
-  if [ -n "$2" ]; then
-    run $MAKE $1 || return 1
-  else
-    run $MAKE $1 || die "Cannot execute $MAKE $1"
+  # $2 represents error or warn
+  run $MAKE $1
+  ret=$?
+
+  if [ $ret -ne 0 ]; then
+    if [ -n "$2" ]; then
+      warn "Failed to execute $MAKE $1: $ret"
+    else
+      die "Failed to execute $MAKE $1: $ret"
+    fi
   fi
+
+  return $ret
 }
 
 function make_distcheck ()
@@ -706,9 +1046,16 @@ function make_distcheck ()
 
 function make_rpm ()
 {
-  if [ -f 'rpm.am' -o -d 'rpm' ]; then
-    run_configure_if_required
-    make_target 'rpm'
+  if command_exists 'rpmbuild'; then
+    if [ -f 'rpm.am' -o -d 'rpm' ]; then
+      run_configure_if_required
+      make_target 'rpm'
+
+      if $jenkins_build_environment; then
+        make_target 'clean'
+      fi
+
+    fi
   fi
 }
 
@@ -716,6 +1063,11 @@ function make_maintainer_clean ()
 {
   run_configure_if_required
   make_target 'maintainer-clean' 'no_error'
+
+  # Lets make sure we really cleaned up the environment
+  assert_no_file 'Makefile'
+  assert_no_file 'configure'
+  assert_no_directory 'autom4te.cache'
 }
 
 function make_check ()
@@ -746,6 +1098,13 @@ function run_configure_if_required ()
   assert_file 'Makefile' 'configure did not produce a Makefile'
 }
 
+function run_make_maintainer_clean_if_possible () 
+{
+  if [ -f 'Makefile' ]; then
+    make_maintainer_clean
+  fi
+}
+
 function run_autoreconf_if_required () 
 {
   if [ ! -x 'configure' ]; then
@@ -753,6 +1112,7 @@ function run_autoreconf_if_required ()
   fi
 
   assert_exec_file 'configure'
+  bash -n configure
 }
 
 function run_autoreconf () 
@@ -766,7 +1126,7 @@ function run_autoreconf ()
     run $BOOTSTRAP_LIBTOOLIZE '--copy' '--install' '--force' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
   fi
 
-  run $AUTORECONF || die "Cannot execute $AUTORECONF"
+  run $AUTORECONF $AUTORECONF_ARGS || die "Cannot execute $AUTORECONF"
 
   eval 'bash -n configure' || die "autoreconf generated a malformed configure"
 }
@@ -777,10 +1137,14 @@ function run ()
     echo "\`$@' $ARGS"
   fi
 
+  if [ -z "$1" ]; then
+    return 127;
+  fi
+
   eval $@ $ARGS
 } 
 
-parse_command_line_options ()
+function parse_command_line_options ()
 {
   local SHORTOPTS=':apcmt:dvh'
 
@@ -814,6 +1178,14 @@ parse_command_line_options ()
         ;;
       h) # help
         echo "bootstrap.sh [options] optional_target ..."
+        echo "  -a # Just run autoreconf";
+        echo "  -p # Print ENV";
+        echo "  -c # Just run configure";
+        echo "  -m # Just run maintainer-clean";
+        echo "  -t # Make target";
+        echo "  -d # Enable debug";
+        echo "  -h # Show help";
+        echo "  -v # Be more verbose in output";
         exit
         ;;
       v) # verbose
@@ -838,7 +1210,7 @@ parse_command_line_options ()
   fi
 }
 
-determine_vcs ()
+function determine_vcs ()
 {
   if [[ -d '.git' ]]; then
     VCS_CHECKOUT=git
@@ -848,6 +1220,8 @@ determine_vcs ()
     VCS_CHECKOUT=svn
   elif [[ -d '.hg' ]]; then
     VCS_CHECKOUT=hg
+  else
+    VCS_CHECKOUT=
   fi
 
   if [[ -n "$VCS_CHECKOUT" ]]; then
@@ -868,10 +1242,10 @@ function autoreconf_setup ()
 {
   # Set ENV MAKE in order to override "make"
   if [[ -z "$MAKE" ]]; then 
-    if command_exists gmake; then
+    if command_exists 'gmake'; then
       MAKE=`type -p gmake`
     else
-      if command_exists make; then
+      if command_exists 'make'; then
         MAKE=`type -p make`
       fi
     fi
@@ -913,6 +1287,7 @@ function autoreconf_setup ()
 
       if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
         echo "Couldn't find user supplied libtoolize, it is required"
+        return 1
       fi
     else
       # If we are using OSX, we first check to see glibtoolize is available
@@ -921,21 +1296,27 @@ function autoreconf_setup ()
 
         if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
           echo "Couldn't find glibtoolize, it is required on OSX"
+          return 1
         fi
       else
         BOOTSTRAP_LIBTOOLIZE=`type -p libtoolize`
 
         if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
           echo "Couldn't find libtoolize, it is required"
+          return 1
         fi
       fi
     fi
+
     if $VERBOSE; then
       LIBTOOLIZE_OPTIONS="--verbose $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
     fi
+
     if $DEBUG; then
       LIBTOOLIZE_OPTIONS="--debug $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
     fi
+
+    # Here we set LIBTOOLIZE to true since we are going to invoke it via BOOTSTRAP_LIBTOOLIZE
     LIBTOOLIZE=true
   fi
 
@@ -973,14 +1354,14 @@ function autoreconf_setup ()
     fi
 
     if [[ -n "$GNU_BUILD_FLAGS" ]]; then
-      AUTORECONF="$AUTORECONF $GNU_BUILD_FLAGS"
+      AUTORECONF_ARGS="$GNU_BUILD_FLAGS"
     fi
   fi
 
   run $AUTORECONF '--help'  &> /dev/null    || die "Failed to run AUTORECONF:$AUTORECONF"
 }
 
-print_setup ()
+function print_setup ()
 {
   saved_debug_status=$DEBUG
   if $DEBUG; then
@@ -991,6 +1372,9 @@ print_setup ()
   echo 'BOOTSTRAP ENV' 
   echo "AUTORECONF=$AUTORECONF"
   echo "HOST_OS=$HOST_OS"
+  echo "VENDOR=$VENDOR"
+  echo "VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
+  echo "VENDOR_RELEASE=$VENDOR_RELEASE"
 
   echo "getopt()"
   if $AUTORECONF_OPTION; then
@@ -1059,7 +1443,7 @@ print_setup ()
   fi
 }
 
-make_clean_option ()
+function make_clean_option ()
 {
   run_configure_if_required
 
@@ -1072,7 +1456,7 @@ make_clean_option ()
   fi
 }
 
-make_for_autoreconf ()
+function make_for_autoreconf ()
 {
   if [ -f 'Makefile' ]; then
     make_maintainer_clean
@@ -1083,7 +1467,7 @@ make_for_autoreconf ()
   assert_no_file 'Makefile'
 }
 
-check_make_target()
+function check_make_target()
 {
   case $1 in
     'self')
@@ -1124,18 +1508,25 @@ check_make_target()
       ;;
     'make_default')
       ;;
-    'test-*')
+    'clang')
+      ;;
+    'clang-analyzer')
       ;;
-    'valgrind-*')
+    test-*)
       ;;
-    'gdb-*')
+    valgrind-*)
+      ;;
+    gdb-*)
       ;;
     'dist')
       ;;
     *)
-      die "Unknown MAKE_TARGET option: $1"
+      echo "Matched default"
+      return 1
       ;;
   esac
+
+  return 0
 }
 
 function bootstrap ()
@@ -1146,7 +1537,9 @@ function bootstrap ()
 
   # Set up whatever we need to do to use autoreconf later
   require_libtoolise
-  autoreconf_setup
+  if ! autoreconf_setup; then
+    return 1
+  fi
 
   if [ -z "$MAKE_TARGET" ]; then
     MAKE_TARGET="make_default"
@@ -1168,7 +1561,7 @@ function bootstrap ()
 
   # Set ENV PREFIX in order to set --prefix for ./configure
   if [[ -n "$PREFIX" ]]; then 
-    push_PREFIX_ARG $PREFIX
+    PREFIX_ARG="--prefix=$PREFIX"
   fi
 
   # We should always have a target by this point
@@ -1181,8 +1574,15 @@ function bootstrap ()
     # If we are running inside of Jenkins, we want to only run some of the possible tests
     if $jenkins_build_environment; then
       check_make_target $target
+      ret=$?
+      if [ $ret -ne 0 ]; then
+        die "Unknown MAKE_TARGET option: $target"
+      fi
     fi
 
+    local snapshot_run=false
+    local valgrind_run=false
+
     case $target in
       'self')
         self_test
@@ -1190,6 +1590,9 @@ function bootstrap ()
       'gdb')
         make_gdb
         ;;
+      'install-html')
+        make_install_html
+        ;;
       'clean_op')
         make_clean_option
         ;;
@@ -1205,16 +1608,48 @@ function bootstrap ()
       'make_default')
         make_default
         ;;
+      'clang')
+        if ! check_clang; then
+          die "clang was not found"
+        fi
+
+        if ! make_for_clang; then
+          die "Failed to build clang: $?"
+        fi
+        ;;
+      'clang-analyzer')
+        if ! check_clang_analyzer; then
+          die "clang-analyzer was not found"
+        fi
+        if ! check_clang; then
+          die "clang was not found"
+        fi
+
+        if ! make_for_clang_analyzer; then
+          die "Failed to build clang-analyzer: $?"
+        fi
+        ;;
       'mingw')
-        make_for_mingw32
+        if ! check_mingw; then
+          die "mingw was not found"
+        fi
+
+        if ! make_for_mingw; then
+          die "Failed to build mingw: $?"
+        fi
         ;;
       'snapshot')
         make_for_snapshot
+        snapshot_run=true
         ;;
       'rpm')
         make_rpm
         ;;
+      'darwin_malloc')
+        make_darwin_malloc
+        ;;
       'valgrind')
+        make_maintainer_clean 
         make_valgrind
         ;;
       'universe')
@@ -1228,16 +1663,24 @@ function bootstrap ()
         make_target "$target"
         ;;
     esac
+
+    if $jenkins_build_environment; then
+      if ! $snapshot_run; then
+        run_make_maintainer_clean_if_possible
+      fi
+    fi
+
   done
 }
 
-main ()
+function main ()
 {
   # Variables we export
   declare -x VCS_CHECKOUT=
 
   # Variables we control globally
   local MAKE_TARGET=
+  local CONFIGURE=
 
   # Options for getopt
   local AUTORECONF_OPTION=false
@@ -1249,12 +1692,24 @@ main ()
   local TARGET_OPTION_ARG=
   local VERBOSE_OPTION=false
 
+  local OLD_CONFIGURE=
+  local OLD_CONFIGURE_ARG=
+  local OLD_PREFIX=
+  local OLD_MAKE=
+  local OLD_TESTS_ENVIRONMENT=
+
   # If we call autoreconf on the platform or not
   local AUTORECONF_REBUILD_HOST=false
   local AUTORECONF_REBUILD=false
 
   local -r top_srcdir=`pwd`
 
+  # Default configure
+  if [ -z "$CONFIGURE" ]; then
+    CONFIGURE="$top_srcdir/configure"
+  fi
+
+
   # Variables for determine_target_platform () and rebuild_host_os ()
   #   UNAME_MACHINE_ARCH= uname -m
   #   VENDOR= apple, redhat, centos, canonical
@@ -1283,7 +1738,16 @@ main ()
   # We don't want Jenkins overriding other variables, so we NULL them.
   if [ -z "$MAKE_TARGET" ]; then
     if $jenkins_build_environment; then
-      MAKE_TARGET='jenkins'
+      if [[ -n "$label" ]]; then
+        check_make_target $label
+        if [ $? -eq 0 ]; then
+          MAKE_TARGET="$label"
+        fi
+      fi
+
+      if [ -z "$MAKE_TARGET" ]; then
+        MAKE_TARGET='jenkins'
+      fi
     fi
   fi
 
@@ -1337,7 +1801,7 @@ function merge ()
   fi
 }
 
-enable_debug ()
+function enable_debug ()
 {
   if ! $DEBUG; then
     local caller_loc=`caller`
@@ -1363,7 +1827,7 @@ function usage ()
 EOF
 }
 
-disable_debug ()
+function disable_debug ()
 {
   set +x
   DEBUG=true
@@ -1386,11 +1850,13 @@ export AUTOHEADER
 export AUTOM4TE
 export AUTOMAKE
 export AUTORECONF
+export CONFIGURE_ARG
 export DEBUG
 export GNU_BUILD_FLAGS
 export LIBTOOLIZE
 export LIBTOOLIZE_OPTIONS
 export MAKE
+export PREFIX_ARG
 export TESTS_ENVIRONMENT
 export VERBOSE
 export WARNINGS